##################################################################################
# This python code includes the function call to estimate the probability maps
# using a trained AttentionBoostModel on a given test set 'x_test' and returns 
# the estimated probability maps. It also includes a function to save the obtained
# probability maps to the specified directory 'path'.
##################################################################################
import numpy as np

def predict(model = None, x_test = [], batch_size=4):
    
	# Null segmentation maps - all equal 0.5
    y_test_null = np.ones((x_test.shape[0], x_test.shape[1], x_test.shape[2], 1)) * 0.5
       
    preds = model.predict([x_test, y_test_null, y_test_null], 
                            batch_size = batch_size, verbose = 1)
            
    return preds


def save_preds(preds = [], names = [], path = ''):

    print('Saving to : ', path)    
    for i in range(preds[0].shape[0]):
        for j in range(len(preds)):            
            fname = path + names[i] + '_' + str(j+1)
            np.savetxt(fname, preds[j][i,:,:,0], fmt='%1.4f')
    print('Predictions are saved')