#include <stdio.h>
#include <stdlib.h>
#include "matrix.h"
#include "mexConversion.h"
#include <mex.h>

/***************************************************/
/********** 2D MATRIX CONVERSIONS ******************/
/***************************************************/
MATRIX convertMxArray2Matrix(const mxArray *xData){
	double *xValues = mxGetPr(xData);
	int row = mxGetM(xData);
	int col = mxGetN(xData);
	MATRIX res = allocateMatrix(row,col);
	int i, j, cnt = 0;
	
	for (j = 0; j < col; j++)
		for (i = 0; i < row; i++)
			res.data[i][j] = (int)xValues[cnt++];	
	
	return res;
}
MATRIXD convertMxArray2MatrixD(const mxArray *xData){
	double *xValues = mxGetPr(xData);
	int row = mxGetM(xData);
	int col = mxGetN(xData);
	MATRIXD res = allocateMatrixD(row,col);
	int i, j, cnt = 0;
	
	for (j = 0; j < col; j++)
		for (i = 0; i < row; i++)
			res.data[i][j] = xValues[cnt++];	
	
	return res;
}
mxArray *convertMatrix2MxArray(MATRIX M){
	mxArray *res = mxCreateDoubleMatrix(M.row,M.column,mxREAL);
	double *xValues = mxGetPr(res);	
	int i, j, cnt = 0;
	
	for (j = 0; j < M.column; j++)
		for (i = 0; i < M.row; i++)
			xValues[cnt++] = M.data[i][j];

	return res;
}
mxArray *convertMatrixD2MxArray(MATRIXD M){
	mxArray *res = mxCreateDoubleMatrix(M.row,M.column,mxREAL);
	double *xValues = mxGetPr(res);	
	int i, j, cnt = 0;
	
	for (j = 0; j < M.column; j++)
		for (i = 0; i < M.row; i++)
			xValues[cnt++] = M.data[i][j];
	
	return res;
}
/***************************************************/
/***************************************************/
/***************************************************/
